(function($) {
/**
 * Attaches a Projekktor element by using the Projekktor Javascript Library
 */
Drupal.behaviors.projekktor = {
  attach: function(context, settings) {
    if ($(settings.projekktor.instances).length) {
      $('video[id^="projekktor-"]', context).once('projekktor', function() {
        var id = $(this).prop('id');
        var jsoptions = settings.projekktor.instances[id];
        // Use the carousel version if those options have been passed.
        // @TODO: This does not check to see if the carousel was added
        // for this paticular instance. Add check to see if id int matches.
        if ($(settings.projekktorJcarousel).length) {
          var readyListener;
          readyListener = function(value, ref) {
            // Adds active class to current jcarousel slide.
            $('.jcarousel-item').each(function(index) {
              if ($(this).index('.jcarousel-item') == (ref.getItemIdx()))
                $(this).addClass('active');
              else
                $(this).removeClass('active');
            });
          }
          // The projekktor instance object for the player with jcarousel.
          projekktor('#' + id, jsoptions, function(player) {
            // Listener to get item info from the player.
            player.addListener('item', readyListener);
            // Click function to play a video with the carousel.
            $('.jcarousel-item').each(function(index) {
              $(this).css('cursor','pointer').click(function(){
                player.setActiveItem(index);
                return false;
              })
            });
          });
        }
        // Else generate just a player object for the instance (no jcarousel).
        else
          projekktor('#' + id, jsoptions);
      });
    }
    // Adds projekktor to generic <video> tag. Optional.
    if ($(settings.projekktor.presetAll).length) {
      $('video', context).once('projekktor', function() {
        var jsoptions = settings.projekktor.presetAll;
        projekktor('video', jsoptions);
      });
    }
  }
};

// Initializes the carousel.
Drupal.behaviors.projekktorJcarousel = {
  attach: function(context, settings) {
    if ($(settings.projekktorJcarousel).length) {
      $('[id^="projekktor-jcarousel-"]', context).once('projekktor-jcarousel', function() {
        var id = $(this).prop('id');
        var ops = settings.projekktorJcarousel[id];
        $('#' + id).jcarousel(ops);
      });
    }
  }
};

})(jQuery);
